From 897460fe425d619d79ed41e11567409f8a0971c3 Mon Sep 17 00:00:00 2001
From: Alexandra Wang <alexandra.wang.oss@gmail.com>
Date: Mon, 3 Aug 2026 15:59:52 -0700
Subject: [PATCH v9 2/4] Unify extended statistics columns and expressions into
 a single stxexprs list

Remove the stxkeys int2vector from pg_statistic_ext. A statistics
object's columns and expressions are now stored together in stxexprs,
in user-written order, with plain columns represented as Var nodes.
The columns previously lived in a separate stxkeys array, sorted by
attnum, which lost that order. This leaves one representation of them
instead of two, in the catalog and in the in-memory StatExtEntry and
StatisticExtInfo structs alike. The pg_stats_ext view accordingly
drops its attnames column and shows all entries in exprs.

Where the code previously kept a keys Bitmapset beside the expression
list, the covered column attnums and the per-expression index are now
derived from the single list on demand.

The user-written order is preserved in the pg_stats_ext view, in the
CREATE STATISTICS command that pg_dump reproduces, and in the MCV
list.  MCV dimensions are positional, so the planner maps a clause to
its dimension through the list instead of assuming columns come first.

The ndistinct and dependencies data identify their attributes by
number, so their order within an item does not affect estimation, but
pg_dump and pg_upgrade reload that data through the pg_ndistinct and
pg_dependencies input functions, which require a canonical order
(columns ascending, then expressions descending). Attnum-sorted
stxkeys used to produce that order; statext_ndistinct_build and
statext_dependencies_build now sort each item explicitly.

Because an entry that reduces to a plain column is treated as that
column, it can be used to estimate queries on that column, which the
separate stxkeys/stxexprs representation could not do. For the same
reason, CREATE STATISTICS now rejects one that duplicates a column
already listed (an expression that const-folds to it, or a virtual
generated column defined on it), the same way a plainly repeated
column is rejected; the duplicate check compares entries after
expanding and const-folding them, not structurally.

This is a prerequisite refactor for the join statistics patch.

Suggested-by: Tom Lane <tgl@sss.pgh.pa.us>
Suggested-by: Tomas Vondra <tomas@vondra.me>
Discussion: https://postgr.es/m/711247.1779913876@sss.pgh.pa.us
---
 doc/src/sgml/catalogs.sgml                    |  19 +-
 doc/src/sgml/perform.sgml                     | 116 ++--
 doc/src/sgml/system-views.sgml                |  13 +-
 src/backend/catalog/system_views.sql          |   7 +-
 src/backend/commands/statscmds.c              | 202 +++----
 src/backend/optimizer/util/plancat.c          |  93 +---
 src/backend/parser/parse_utilcmd.c            |  65 +--
 src/backend/statistics/dependencies.c         |  61 ++-
 src/backend/statistics/extended_stats.c       | 516 +++++++++++-------
 src/backend/statistics/extended_stats_funcs.c | 159 +++---
 src/backend/statistics/mcv.c                  |  75 ++-
 src/backend/statistics/mvdistinct.c           |  23 +-
 src/backend/utils/adt/ruleutils.c             | 304 ++++++-----
 src/backend/utils/adt/selfuncs.c              |  23 +-
 src/bin/psql/describe.c                       |  20 +-
 src/include/catalog/pg_proc.dat               |   4 +-
 src/include/catalog/pg_statistic_ext.h        |  15 +-
 src/include/nodes/pathnodes.h                 |   5 +-
 .../statistics/extended_stats_internal.h      |   7 +-
 src/include/statistics/statistics.h           |   5 +
 .../regress/expected/create_table_like.out    |   9 +-
 src/test/regress/expected/oidjoins.out        |   1 -
 src/test/regress/expected/rules.out           |   5 +-
 src/test/regress/expected/stats_ext.out       | 143 ++++-
 src/test/regress/expected/stats_import.out    | 119 +++-
 src/test/regress/sql/create_table_like.sql    |   9 +-
 src/test/regress/sql/stats_ext.sql            |  77 ++-
 src/test/regress/sql/stats_import.sql         | 102 ++++
 28 files changed, 1320 insertions(+), 877 deletions(-)

diff --git a/doc/src/sgml/catalogs.sgml b/doc/src/sgml/catalogs.sgml
index 6066c4784f4..f747b9528d2 100644
--- a/doc/src/sgml/catalogs.sgml
+++ b/doc/src/sgml/catalogs.sgml
@@ -8323,18 +8323,6 @@ SCRAM-SHA-256$<replaceable>&lt;iteration count&gt;</replaceable>:<replaceable>&l
       </para></entry>
      </row>
 
-     <row>
-      <entry role="catalog_table_entry"><para role="column_definition">
-       <structfield>stxkeys</structfield> <type>int2vector</type>
-       (references <link linkend="catalog-pg-attribute"><structname>pg_attribute</structname></link>.<structfield>attnum</structfield>)
-      </para>
-      <para>
-       An array of attribute numbers, indicating which table columns are
-       covered by this statistics object;
-       for example a value of <literal>1 3</literal> would
-       mean that the first and the third table columns are covered
-      </para></entry>
-     </row>
 
      <row>
       <entry role="catalog_table_entry"><para role="column_definition">
@@ -8373,9 +8361,10 @@ SCRAM-SHA-256$<replaceable>&lt;iteration count&gt;</replaceable>:<replaceable>&l
       </para>
       <para>
        Expression trees (in <function>nodeToString()</function>
-       representation) for statistics object attributes that are not simple
-       column references.  This is a list with one element per expression.
-       Null if all statistics object attributes are simple references.
+       representation) for the columns and expressions the statistics object
+       is defined on.  Both column
+       references and expressions are stored here, with one element per
+       column or expression, in the order they were written.
       </para></entry>
      </row>
 
diff --git a/doc/src/sgml/perform.sgml b/doc/src/sgml/perform.sgml
index 604e8578a8d..ba136e2b501 100644
--- a/doc/src/sgml/perform.sgml
+++ b/doc/src/sgml/perform.sgml
@@ -1541,30 +1541,32 @@ CREATE STATISTICS stts (dependencies) ON city, zip FROM zipcodes;
 
 ANALYZE zipcodes;
 
-SELECT stxkeys AS k, jsonb_pretty(stxddependencies::text::jsonb) AS dep
+SELECT jsonb_pretty(stxddependencies::text::jsonb) AS dep
   FROM pg_statistic_ext JOIN pg_statistic_ext_data ON (oid = stxoid)
   WHERE stxname = 'stts';
--[ RECORD 1 ]--------------------
-k   | 1 5
-dep | [                          +
-    |     {                      +
-    |         "degree": 1.000000,+
-    |         "attributes": [    +
-    |             1              +
-    |         ],                 +
-    |         "dependency": 5    +
-    |     },                     +
-    |     {                      +
-    |         "degree": 0.423130,+
-    |         "attributes": [    +
-    |             5              +
-    |         ],                 +
-    |         "dependency": 1    +
-    |     }                      +
-    | ]
+             dep
+-----------------------------
+ [                          +
+     {                      +
+         "degree": 1.000000,+
+         "attributes": [    +
+             1              +
+         ],                 +
+         "dependency": 5    +
+     },                     +
+     {                      +
+         "degree": 0.423130,+
+         "attributes": [    +
+             5              +
+         ],                 +
+         "dependency": 1    +
+     }                      +
+ ]
 (1 row)
 </programlisting>
-     Here it can be seen that column 1 (zip code) fully determines column
+     The dependency data identifies columns by attribute number: in this
+     table zip is attribute 1 and city is attribute 5.  It can then be seen
+     that column 1 (zip code) fully determines column
      5 (city) so the coefficient is 1.0, while city only determines zip code
      about 42% of the time, meaning that there are many cities (58%) that are
      represented by more than a single ZIP code.
@@ -1647,46 +1649,48 @@ CREATE STATISTICS stts2 (ndistinct) ON city, state, zip FROM zipcodes;
 
 ANALYZE zipcodes;
 
-SELECT stxkeys AS k, jsonb_pretty(stxdndistinct::text::jsonb) AS nd
+SELECT jsonb_pretty(stxdndistinct::text::jsonb) AS nd
   FROM pg_statistic_ext JOIN pg_statistic_ext_data on (oid = stxoid)
   WHERE stxname = 'stts2';
--[ RECORD 1 ]-------------------
-k  | 1 2 5
-nd | [                          +
-   |     {                      +
-   |         "ndistinct": 33178,+
-   |         "attributes": [    +
-   |             1,             +
-   |             2              +
-   |         ]                  +
-   |     },                     +
-   |     {                      +
-   |         "ndistinct": 33178,+
-   |         "attributes": [    +
-   |             1,             +
-   |             5              +
-   |         ]                  +
-   |     },                     +
-   |     {                      +
-   |         "ndistinct": 27435,+
-   |         "attributes": [    +
-   |             2,             +
-   |             5              +
-   |         ]                  +
-   |     },                     +
-   |     {                      +
-   |         "ndistinct": 33178,+
-   |         "attributes": [    +
-   |             1,             +
-   |             2,             +
-   |             5              +
-   |         ]                  +
-   |     }                      +
-   | ]
+             nd
+-----------------------------
+ [                          +
+     {                      +
+         "ndistinct": 33178,+
+         "attributes": [    +
+             1,             +
+             2              +
+         ]                  +
+     },                     +
+     {                      +
+         "ndistinct": 33178,+
+         "attributes": [    +
+             1,             +
+             5              +
+         ]                  +
+     },                     +
+     {                      +
+         "ndistinct": 27435,+
+         "attributes": [    +
+             2,             +
+             5              +
+         ]                  +
+     },                     +
+     {                      +
+         "ndistinct": 33178,+
+         "attributes": [    +
+             1,             +
+             2,             +
+             5              +
+         ]                  +
+     }                      +
+ ]
 (1 row)
 </programlisting>
-     This indicates that there are three combinations of columns that
-     have 33178 distinct values: ZIP code and state; ZIP code and city;
+     As above, the columns appear by attribute number: zip is 1, state is 2
+     and city is 5.  This indicates that there are three combinations of
+     columns that have 33178 distinct values: ZIP code and state; ZIP code
+     and city;
      and ZIP code, city and state (the fact that they are all equal is
      expected given that ZIP code alone is unique in this table).  On the
      other hand, the combination of city and state has only 27435 distinct
diff --git a/doc/src/sgml/system-views.sgml b/doc/src/sgml/system-views.sgml
index 5ea19d68622..f73a9b1f7b2 100644
--- a/doc/src/sgml/system-views.sgml
+++ b/doc/src/sgml/system-views.sgml
@@ -4737,22 +4737,13 @@ SELECT * FROM pg_locks pl LEFT JOIN pg_prepared_xacts ppx
       </para></entry>
      </row>
 
-     <row>
-      <entry role="catalog_table_entry"><para role="column_definition">
-       <structfield>attnames</structfield> <type>name[]</type>
-       (references <link linkend="catalog-pg-attribute"><structname>pg_attribute</structname></link>.<structfield>attname</structfield>)
-      </para>
-      <para>
-       Names of the columns included in the extended statistics object
-      </para></entry>
-     </row>
-
      <row>
       <entry role="catalog_table_entry"><para role="column_definition">
        <structfield>exprs</structfield> <type>text[]</type>
       </para>
       <para>
-       Expressions included in the extended statistics object
+       The columns and expressions the statistics object is
+       defined on, in the order they were written
       </para></entry>
       </row>
 
diff --git a/src/backend/catalog/system_views.sql b/src/backend/catalog/system_views.sql
index 090281a03dd..599c629e004 100644
--- a/src/backend/catalog/system_views.sql
+++ b/src/backend/catalog/system_views.sql
@@ -285,12 +285,7 @@ CREATE VIEW pg_stats_ext WITH (security_barrier) AS
            s.stxname AS statistics_name,
            s.oid AS statistics_id,
            pg_get_userbyid(s.stxowner) AS statistics_owner,
-           ( SELECT array_agg(a.attname ORDER BY a.attnum)
-             FROM unnest(s.stxkeys) k
-                  JOIN pg_attribute a
-                       ON (a.attrelid = s.stxrelid AND a.attnum = k)
-           ) AS attnames,
-           pg_get_statisticsobjdef_expressions(s.oid) as exprs,
+           pg_get_statisticsobjdef_columns(s.oid) AS exprs,
            s.stxkind AS kinds,
            sd.stxdinherit AS inherited,
            sd.stxdndistinct AS n_distinct,
diff --git a/src/backend/commands/statscmds.c b/src/backend/commands/statscmds.c
index ce98ebb35ea..ecddbea32ec 100644
--- a/src/backend/commands/statscmds.c
+++ b/src/backend/commands/statscmds.c
@@ -31,6 +31,7 @@
 #include "nodes/makefuncs.h"
 #include "nodes/nodeFuncs.h"
 #include "optimizer/optimizer.h"
+#include "rewrite/rewriteHandler.h"
 #include "statistics/statistics.h"
 #include "utils/acl.h"
 #include "utils/builtins.h"
@@ -45,26 +46,12 @@ static char *ChooseExtendedStatisticName(const char *name1, const char *name2,
 										 const char *label, Oid namespaceid);
 static char *ChooseExtendedStatisticNameAddition(List *exprs);
 
-
-/* qsort comparator for the attnums in CreateStatistics */
-static int
-compare_int16(const void *a, const void *b)
-{
-	int			av = *(const int16 *) a;
-	int			bv = *(const int16 *) b;
-
-	/* this can't overflow if int is wider than int16 */
-	return (av - bv);
-}
-
 /*
  *		CREATE STATISTICS
  */
 ObjectAddress
 CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 {
-	int16		attnums[STATS_MAX_DIMENSIONS];
-	int			nattnums = 0;
 	int			numcols;
 	char	   *namestr;
 	NameData	stxname;
@@ -74,8 +61,9 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	HeapTuple	htup;
 	Datum		values[Natts_pg_statistic_ext];
 	bool		nulls[Natts_pg_statistic_ext];
-	int2vector *stxkeys;
 	List	   *stxexprs = NIL;
+	List	   *folded_exprs;
+	char	   *exprsString;
 	Datum		exprsDatum;
 	Relation	statrel;
 	Relation	rel = NULL;
@@ -89,8 +77,8 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	bool		build_dependencies;
 	bool		build_mcv;
 	bool		build_expressions;
+	bool		has_simple_var = false;
 	bool		requested_type = false;
-	int			i;
 	ListCell   *cell;
 	ListCell   *cell2;
 
@@ -244,8 +232,8 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 						STATS_MAX_DIMENSIONS)));
 
 	/*
-	 * Convert the expression list to a simple array of attnums, but also keep
-	 * a list of more complex expressions.  While at it, enforce some
+	 * Convert the expression list to a list of expression trees.  Simple
+	 * column references are stored as Var nodes.  While at it, enforce some
 	 * constraints - we don't allow extended statistics on system attributes,
 	 * and we require the data type to have a less-than operator, if we're
 	 * building multivariate statistics.
@@ -300,24 +288,14 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 									   format_type_be(attForm->atttypid))));
 			}
 
-			/* Treat virtual generated columns as expressions */
-			if (attForm->attgenerated == ATTRIBUTE_GENERATED_VIRTUAL)
-			{
-				Node	   *expr;
-
-				expr = (Node *) makeVar(1,
-										attForm->attnum,
-										attForm->atttypid,
-										attForm->atttypmod,
-										attForm->attcollation,
-										0);
-				stxexprs = lappend(stxexprs, expr);
-			}
-			else
-			{
-				attnums[nattnums] = attForm->attnum;
-				nattnums++;
-			}
+			stxexprs = lappend(stxexprs,
+							   (Node *) makeVar(1,
+												attForm->attnum,
+												attForm->atttypid,
+												attForm->atttypmod,
+												attForm->attcollation,
+												0));
+			has_simple_var = true;
 			ReleaseSysCache(atttuple);
 		}
 		else if (IsA(selem->expr, Var)) /* column reference in parens */
@@ -347,16 +325,8 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 									   format_type_be(var->vartype))));
 			}
 
-			/* Treat virtual generated columns as expressions */
-			if (get_attgenerated(relid, var->varattno) == ATTRIBUTE_GENERATED_VIRTUAL)
-			{
-				stxexprs = lappend(stxexprs, (Node *) var);
-			}
-			else
-			{
-				attnums[nattnums] = var->varattno;
-				nattnums++;
-			}
+			stxexprs = lappend(stxexprs, (Node *) var);
+			has_simple_var = true;
 		}
 		else					/* expression */
 		{
@@ -407,20 +377,23 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	 * that we're building statistics on a single expression (or virtual
 	 * generated column).
 	 */
-	if (numcols < 2 && list_length(stxexprs) != 1)
-		ereport(ERROR,
-				errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
-				errmsg("cannot create extended statistics on a single non-virtual column"),
-				errdetail("Univariate statistics are already built for each individual non-virtual table column."));
+	if (numcols == 1)
+	{
+		Node	   *single = (Node *) linitial(stxexprs);
 
-	/*
-	 * Parse the statistics kinds (not allowed when building univariate
-	 * statistics).
-	 */
-	if (numcols == 1 && stmt->stat_types != NIL)
-		ereport(ERROR,
-				errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
-				errmsg("cannot specify statistics kinds when building univariate statistics"));
+		if (IsA(single, Var) &&
+			get_attgenerated(relid, ((Var *) single)->varattno) != ATTRIBUTE_GENERATED_VIRTUAL)
+			ereport(ERROR,
+					errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+					errmsg("cannot create extended statistics on a single non-virtual column"),
+					errdetail("Univariate statistics are already built for each individual non-virtual table column."));
+
+		/* statistics kinds are not allowed with univariate statistics */
+		if (stmt->stat_types != NIL)
+			ereport(ERROR,
+					errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					errmsg("cannot specify statistics kinds when building univariate statistics"));
+	}
 
 	build_ndistinct = false;
 	build_dependencies = false;
@@ -463,50 +436,49 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	}
 
 	/*
-	 * When there are non-trivial expressions, build the expression stats
-	 * automatically. This allows calculating good estimates for stats that
-	 * consider per-clause estimates (e.g. functional dependencies).
+	 * Build per-expression statistics automatically when the object covers
+	 * anything that has no pg_statistic entry of its own: complex
+	 * expressions, or virtual generated columns (stored as Var nodes, but
+	 * like expressions they get no pg_statistic row, so they need
+	 * per-expression stats).  Plain columns are skipped, since they already
+	 * have univariate statistics in pg_statistic.  These give good estimates
+	 * where per-clause estimates matter (e.g. functional dependencies).
 	 */
-	build_expressions = (stxexprs != NIL);
-
-	/*
-	 * Sort the attnums, which makes detecting duplicates somewhat easier, and
-	 * it does not hurt (it does not matter for the contents, unlike for
-	 * indexes, for example).
-	 */
-	qsort(attnums, nattnums, sizeof(int16), compare_int16);
-
-	/*
-	 * Check for duplicates in the list of columns. The attnums are sorted so
-	 * just check consecutive elements.
-	 */
-	for (i = 1; i < nattnums; i++)
+	build_expressions = false;
+	foreach(cell, stxexprs)
 	{
-		if (attnums[i] == attnums[i - 1])
-			ereport(ERROR,
-					(errcode(ERRCODE_DUPLICATE_COLUMN),
-					 errmsg("duplicate column name in statistics definition")));
+		Node	   *expr = (Node *) lfirst(cell);
+
+		if (!IsA(expr, Var) ||
+			get_attgenerated(relid, ((Var *) expr)->varattno) == ATTRIBUTE_GENERATED_VIRTUAL)
+		{
+			build_expressions = true;
+			break;
+		}
 	}
 
 	/*
-	 * Check for duplicate expressions. We do two loops, counting the
-	 * occurrences of each expression. This is O(N^2) but we only allow small
-	 * number of expressions and it's not executed often.
+	 * Check for duplicate entries. We do two loops, counting the occurrences
+	 * of each entry. This is O(N^2) but we only allow small number of entries
+	 * and it's not executed often.
 	 *
-	 * XXX We don't cross-check attributes and expressions, because it does
-	 * not seem worth it. In principle we could check that expressions don't
-	 * contain trivial attribute references like "(a)", but the reasoning is
-	 * similar to why we don't bother with extracting columns from
-	 * expressions. It's either expensive or very easy to defeat for
-	 * determined user, and there's no risk if we allow such statistics (the
-	 * statistics is useless, but harmless).
+	 * We compare the entries after expanding generated columns and
+	 * const-folding, so that an entry which resolves to a column already
+	 * listed is caught as a duplicate; a plain structural comparison would
+	 * miss it. References that are equivalent but do not fold to the same
+	 * node (e.g. "a" vs "(a+0)") are still not caught; such an object is
+	 * useless but harmless.
 	 */
-	foreach(cell, stxexprs)
+	folded_exprs = (List *) expand_generated_columns_in_expr((Node *) stxexprs,
+															 rel, 1);
+	folded_exprs = (List *) eval_const_expressions(NULL, (Node *) folded_exprs);
+
+	foreach(cell, folded_exprs)
 	{
 		Node	   *expr1 = (Node *) lfirst(cell);
 		int			cnt = 0;
 
-		foreach(cell2, stxexprs)
+		foreach(cell2, folded_exprs)
 		{
 			Node	   *expr2 = (Node *) lfirst(cell2);
 
@@ -514,18 +486,15 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 				cnt += 1;
 		}
 
-		/* every expression should find at least itself */
+		/* every entry should find at least itself */
 		Assert(cnt >= 1);
 
 		if (cnt > 1)
 			ereport(ERROR,
 					(errcode(ERRCODE_DUPLICATE_COLUMN),
-					 errmsg("duplicate expression in statistics definition")));
+					 errmsg("duplicate column or expression in statistics definition")));
 	}
 
-	/* Form an int2vector representation of the sorted column list */
-	stxkeys = buildint2vector(attnums, nattnums);
-
 	/* construct the char array of enabled statistic types */
 	ntypes = 0;
 	if (build_ndistinct)
@@ -539,17 +508,10 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	Assert(ntypes > 0 && ntypes <= lengthof(types));
 	stxkind = construct_array_builtin(types, ntypes, CHAROID);
 
-	/* convert the expressions (if any) to a text datum */
-	if (stxexprs != NIL)
-	{
-		char	   *exprsString;
-
-		exprsString = nodeToString(stxexprs);
-		exprsDatum = CStringGetTextDatum(exprsString);
-		pfree(exprsString);
-	}
-	else
-		exprsDatum = (Datum) 0;
+	/* convert the expression list to a text datum */
+	exprsString = nodeToString(stxexprs);
+	exprsDatum = CStringGetTextDatum(exprsString);
+	pfree(exprsString);
 
 	statrel = table_open(StatisticExtRelationId, RowExclusiveLock);
 
@@ -566,13 +528,9 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	values[Anum_pg_statistic_ext_stxname - 1] = NameGetDatum(&stxname);
 	values[Anum_pg_statistic_ext_stxnamespace - 1] = ObjectIdGetDatum(namespaceId);
 	values[Anum_pg_statistic_ext_stxowner - 1] = ObjectIdGetDatum(stxowner);
-	values[Anum_pg_statistic_ext_stxkeys - 1] = PointerGetDatum(stxkeys);
 	nulls[Anum_pg_statistic_ext_stxstattarget - 1] = true;
 	values[Anum_pg_statistic_ext_stxkind - 1] = PointerGetDatum(stxkind);
-
 	values[Anum_pg_statistic_ext_stxexprs - 1] = exprsDatum;
-	if (exprsDatum == (Datum) 0)
-		nulls[Anum_pg_statistic_ext_stxexprs - 1] = true;
 
 	/* insert it into pg_statistic_ext */
 	htup = heap_form_tuple(statrel->rd_att, values, nulls);
@@ -602,13 +560,6 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	 */
 	ObjectAddressSet(myself, StatisticExtRelationId, statoid);
 
-	/* add dependencies for plain column references */
-	for (i = 0; i < nattnums; i++)
-	{
-		ObjectAddressSubSet(parentobject, RelationRelationId, relid, attnums[i]);
-		recordDependencyOn(&myself, &parentobject, DEPENDENCY_AUTO);
-	}
-
 	/*
 	 * If there are no dependencies on a column, give the statistics object an
 	 * auto dependency on the whole table.  In most cases, this will be
@@ -620,7 +571,7 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	 * dependency, because recordDependencyOnSingleRelExpr may not create any
 	 * dependencies for whole-row Vars.
 	 */
-	if (!nattnums)
+	if (!has_simple_var)
 	{
 		ObjectAddressSet(parentobject, RelationRelationId, relid);
 		recordDependencyOn(&myself, &parentobject, DEPENDENCY_AUTO);
@@ -630,12 +581,11 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	 * Store dependencies on anything mentioned in statistics expressions,
 	 * just like we do for index expressions.
 	 */
-	if (stxexprs)
-		recordDependencyOnSingleRelExpr(&myself,
-										(Node *) stxexprs,
-										relid,
-										DEPENDENCY_NORMAL,
-										DEPENDENCY_AUTO, false);
+	recordDependencyOnSingleRelExpr(&myself,
+									(Node *) stxexprs,
+									relid,
+									DEPENDENCY_NORMAL,
+									DEPENDENCY_AUTO, false);
 
 	/*
 	 * Also add dependencies on namespace and owner.  These are required
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
index 7c4be174869..da92d70b4af 100644
--- a/src/backend/optimizer/util/plancat.c
+++ b/src/backend/optimizer/util/plancat.c
@@ -1654,7 +1654,7 @@ get_relation_constraints(PlannerInfo *root,
 static void
 get_relation_statistics_worker(List **stainfos, RelOptInfo *rel,
 							   Oid statOid, bool inh,
-							   Bitmapset *keys, List *exprs)
+							   List *exprs)
 {
 	Form_pg_statistic_ext_data dataForm;
 	HeapTuple	dtup;
@@ -1675,7 +1675,6 @@ get_relation_statistics_worker(List **stainfos, RelOptInfo *rel,
 		info->inherit = dataForm->stxdinherit;
 		info->rel = rel;
 		info->kind = STATS_EXT_NDISTINCT;
-		info->keys = bms_copy(keys);
 		info->exprs = exprs;
 
 		*stainfos = lappend(*stainfos, info);
@@ -1689,7 +1688,6 @@ get_relation_statistics_worker(List **stainfos, RelOptInfo *rel,
 		info->inherit = dataForm->stxdinherit;
 		info->rel = rel;
 		info->kind = STATS_EXT_DEPENDENCIES;
-		info->keys = bms_copy(keys);
 		info->exprs = exprs;
 
 		*stainfos = lappend(*stainfos, info);
@@ -1703,7 +1701,6 @@ get_relation_statistics_worker(List **stainfos, RelOptInfo *rel,
 		info->inherit = dataForm->stxdinherit;
 		info->rel = rel;
 		info->kind = STATS_EXT_MCV;
-		info->keys = bms_copy(keys);
 		info->exprs = exprs;
 
 		*stainfos = lappend(*stainfos, info);
@@ -1717,7 +1714,6 @@ get_relation_statistics_worker(List **stainfos, RelOptInfo *rel,
 		info->inherit = dataForm->stxdinherit;
 		info->rel = rel;
 		info->kind = STATS_EXT_EXPRESSIONS;
-		info->keys = bms_copy(keys);
 		info->exprs = exprs;
 
 		*stainfos = lappend(*stainfos, info);
@@ -1748,88 +1744,57 @@ get_relation_statistics(PlannerInfo *root, RelOptInfo *rel,
 	foreach(l, statoidlist)
 	{
 		Oid			statOid = lfirst_oid(l);
-		Form_pg_statistic_ext staForm;
 		HeapTuple	htup;
-		Bitmapset  *keys = NULL;
 		List	   *exprs = NIL;
-		int			i;
 
 		htup = SearchSysCache1(STATEXTOID, ObjectIdGetDatum(statOid));
 		if (!HeapTupleIsValid(htup))
 			elog(ERROR, "cache lookup failed for statistics object %u", statOid);
-		staForm = (Form_pg_statistic_ext) GETSTRUCT(htup);
-
-		/*
-		 * First, build the array of columns covered.  This is ultimately
-		 * wasted if no stats within the object have actually been built, but
-		 * it doesn't seem worth troubling over that case.
-		 */
-		for (i = 0; i < staForm->stxkeys.dim1; i++)
-			keys = bms_add_member(keys, staForm->stxkeys.values[i]);
 
 		/*
-		 * Preprocess expressions (if any). We read the expressions, fix the
+		 * Preprocess the columns and expressions. We read them, fix the
 		 * varnos, and run them through eval_const_expressions.
 		 *
 		 * XXX We don't know yet if there are any data for this stats object,
 		 * with either stxdinherit value. But it's reasonable to assume there
 		 * is at least one of those, possibly both. So it's better to process
-		 * keys and expressions here.
+		 * columns and expressions here.
 		 */
-		{
-			bool		isnull;
-			Datum		datum;
-
-			/* decode expression (if any) */
-			datum = SysCacheGetAttr(STATEXTOID, htup,
-									Anum_pg_statistic_ext_stxexprs, &isnull);
+		exprs = statext_get_stxexprs(htup, relation);
 
-			if (!isnull)
-			{
-				char	   *exprsString;
-
-				exprsString = TextDatumGetCString(datum);
-				exprs = (List *) stringToNode(exprsString);
-				pfree(exprsString);
-
-				/* Expand virtual generated columns in the expressions */
-				exprs = (List *) expand_generated_columns_in_expr((Node *) exprs, relation, 1);
-
-				/*
-				 * Modify the copies we obtain from the relcache to have the
-				 * correct varno for the parent relation, so that they match
-				 * up correctly against qual clauses.
-				 *
-				 * This must be done before const-simplification because
-				 * eval_const_expressions reduces NullTest for Vars based on
-				 * varno.
-				 */
-				if (varno != 1)
-					ChangeVarNodes((Node *) exprs, 1, varno, 0);
+		/*
+		 * Modify the copies we obtain from the relcache to have the correct
+		 * varno for the parent relation, so that they match up correctly
+		 * against qual clauses.
+		 *
+		 * This must be done before const-simplification because
+		 * eval_const_expressions reduces NullTest for Vars based on varno.
+		 */
+		if (varno != 1)
+			ChangeVarNodes((Node *) exprs, 1, varno, 0);
 
-				/*
-				 * Run the expressions through eval_const_expressions. This is
-				 * not just an optimization, but is necessary, because the
-				 * planner will be comparing them to similarly-processed qual
-				 * clauses, and may fail to detect valid matches without this.
-				 * We must not use canonicalize_qual, however, since these
-				 * aren't qual expressions.
-				 */
-				exprs = (List *) eval_const_expressions(root, (Node *) exprs);
+		/*
+		 * Run the columns and expressions through eval_const_expressions.
+		 * This is not just an optimization, but is necessary, because the
+		 * planner will be comparing them to similarly-processed qual clauses,
+		 * and may fail to detect valid matches without this.  We must not use
+		 * canonicalize_qual, however, since these aren't qual expressions.
+		 * Plain-column Vars are unaffected.  statext_get_stxexprs() already
+		 * const-folded these with a NULL root; we redo it here with the real
+		 * root so the varno-dependent reductions noted above can apply.
+		 */
+		exprs = (List *) eval_const_expressions(root, (Node *) exprs);
 
-				/* May as well fix opfuncids too */
-				fix_opfuncids((Node *) exprs);
-			}
-		}
+		/* May as well fix opfuncids too */
+		fix_opfuncids((Node *) exprs);
 
 		/* extract statistics for possible values of stxdinherit flag */
 
-		get_relation_statistics_worker(&stainfos, rel, statOid, true, keys, exprs);
+		get_relation_statistics_worker(&stainfos, rel, statOid, true, exprs);
 
-		get_relation_statistics_worker(&stainfos, rel, statOid, false, keys, exprs);
+		get_relation_statistics_worker(&stainfos, rel, statOid, false, exprs);
 
 		ReleaseSysCache(htup);
-		bms_free(keys);
 	}
 
 	list_free(statoidlist);
